class Game extends Phaser.Scene {
    constructor(game) {
        super('Game');
        this.game = game;
    }

    preload() {
        this.gm = new GamingBoard();
        this.game.scene.add('GamingBoard', this.gm);
    }

    create() {
        //this.add.image(0,0,'background').alpha = 0.1;

        let btn = this.add.sprite(WIDTH_WINDOW / 1.5, (HEIGHT_WINDOW / 3) * 2, 'btn_play').setOrigin(0.5, 0.5).setInteractive();
        //btn.setFrame(0);
        btn.on('pointerout', () => btn.setFrame(0));
        btn.on('pointerover', () => btn.setFrame(1));
        btn.on('pointerdown', () => this.clickPlay(btn));
        this.scene.launch('GamingBoard');
        this.scene.pause('GamingBoard');
        this.tree = new Tree(WIDTH_WINDOW / 1.5, 100, this);
        this.tree.addNode(new MoveRectangle(true, WIDTH_WINDOW/1.2, 400, 100, 100, this))
        this.tree.addNode(new AttackRectangle(WIDTH_WINDOW/1.5, 400, 100, 100, this));
        this.input.on('drag', this.doDrag);
    }

    update(time, delta) {
        super.update(time, delta);
        this.tree.updateLines();
    }

    doDrag(pointer, target, dragX, dragY) {
        target.setX(dragX);
        target.setY(dragY);
    }

    clickPlay(btn) {
        btn.setFrame(2);
        if (this.scene.isPaused('GamingBoard'))
            this.resume();
        else
            this.scene.pause('GamingBoard');
    }

    resume() {
        const sortDesc = (a, b) => a.getX() - b.getX();
        this.tree.lNode.sort(sortDesc);
        this.gm.modifyNodes(this.tree.lNode);
        this.scene.resume('GamingBoard');
    }
}