class MoveRectangle extends Move {
    constructor(toward, x, y, width, height, scene) {
        super(toward);
        this.color = COLOR_MOVE;
        this.rect = new Phaser.GameObjects.Rectangle(scene, x, y, width, height, this.color);
        this.line = scene.add.graphics();
    }

    getX() {
        return this.rect.x;
    }

    addLine(x, y) {
        this.xOrigin = x;
        this.yOrigin = y;
        this.updateLine();
    }

    updateLine() {
        if (this.xLine !== this.rect.x || this.yLine !== this.rect.y) {
            this.xLine = this.rect.x;
            this.yLine = this.rect.y;
            this.line.clear();
            this.line.lineStyle(10, 0xffffff, 1);
            this.line.lineBetween(this.xOrigin, this.yOrigin, this.rect.x, this.rect.y);
        }
    }
}